/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-pr2-gazebo-plugins-2.0.3-0precise-20150808-1756/msg/PlugCommand.msg
 *
 */


#ifndef PR2_GAZEBO_PLUGINS_MESSAGE_PLUGCOMMAND_H
#define PR2_GAZEBO_PLUGINS_MESSAGE_PLUGCOMMAND_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace pr2_gazebo_plugins
{
template <class ContainerAllocator>
struct PlugCommand_
{
  typedef PlugCommand_<ContainerAllocator> Type;

  PlugCommand_()
    : ac_present(false)
    , charge_rate(0.0)
    , discharge_rate(0.0)
    , charge(0.0)  {
    }
  PlugCommand_(const ContainerAllocator& _alloc)
    : ac_present(false)
    , charge_rate(0.0)
    , discharge_rate(0.0)
    , charge(0.0)  {
    }



   typedef uint8_t _ac_present_type;
  _ac_present_type ac_present;

   typedef double _charge_rate_type;
  _charge_rate_type charge_rate;

   typedef double _discharge_rate_type;
  _discharge_rate_type discharge_rate;

   typedef double _charge_type;
  _charge_type charge;




  typedef boost::shared_ptr< ::pr2_gazebo_plugins::PlugCommand_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::pr2_gazebo_plugins::PlugCommand_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct PlugCommand_

typedef ::pr2_gazebo_plugins::PlugCommand_<std::allocator<void> > PlugCommand;

typedef boost::shared_ptr< ::pr2_gazebo_plugins::PlugCommand > PlugCommandPtr;
typedef boost::shared_ptr< ::pr2_gazebo_plugins::PlugCommand const> PlugCommandConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::pr2_gazebo_plugins::PlugCommand_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::pr2_gazebo_plugins::PlugCommand_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace pr2_gazebo_plugins

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'nav_msgs': ['/opt/ros/hydro/share/nav_msgs/cmake/../msg'], 'pr2_gazebo_plugins': ['/tmp/buildd/ros-hydro-pr2-gazebo-plugins-2.0.3-0precise-20150808-1756/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'pr2_msgs': ['/opt/ros/hydro/share/pr2_msgs/cmake/../msg'], 'diagnostic_msgs': ['/opt/ros/hydro/share/diagnostic_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::pr2_gazebo_plugins::PlugCommand_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::pr2_gazebo_plugins::PlugCommand_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pr2_gazebo_plugins::PlugCommand_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pr2_gazebo_plugins::PlugCommand_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pr2_gazebo_plugins::PlugCommand_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pr2_gazebo_plugins::PlugCommand_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::pr2_gazebo_plugins::PlugCommand_<ContainerAllocator> >
{
  static const char* value()
  {
    return "852b7035ee3e7fa6390824cf7b7e6dd1";
  }

  static const char* value(const ::pr2_gazebo_plugins::PlugCommand_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x852b7035ee3e7fa6ULL;
  static const uint64_t static_value2 = 0x390824cf7b7e6dd1ULL;
};

template<class ContainerAllocator>
struct DataType< ::pr2_gazebo_plugins::PlugCommand_<ContainerAllocator> >
{
  static const char* value()
  {
    return "pr2_gazebo_plugins/PlugCommand";
  }

  static const char* value(const ::pr2_gazebo_plugins::PlugCommand_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::pr2_gazebo_plugins::PlugCommand_<ContainerAllocator> >
{
  static const char* value()
  {
    return "bool ac_present\n\
float64 charge_rate\n\
float64 discharge_rate\n\
float64 charge\n\
";
  }

  static const char* value(const ::pr2_gazebo_plugins::PlugCommand_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::pr2_gazebo_plugins::PlugCommand_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.ac_present);
      stream.next(m.charge_rate);
      stream.next(m.discharge_rate);
      stream.next(m.charge);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct PlugCommand_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::pr2_gazebo_plugins::PlugCommand_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::pr2_gazebo_plugins::PlugCommand_<ContainerAllocator>& v)
  {
    s << indent << "ac_present: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.ac_present);
    s << indent << "charge_rate: ";
    Printer<double>::stream(s, indent + "  ", v.charge_rate);
    s << indent << "discharge_rate: ";
    Printer<double>::stream(s, indent + "  ", v.discharge_rate);
    s << indent << "charge: ";
    Printer<double>::stream(s, indent + "  ", v.charge);
  }
};

} // namespace message_operations
} // namespace ros

#endif // PR2_GAZEBO_PLUGINS_MESSAGE_PLUGCOMMAND_H
